/**
 * Created by oleg on 17.03.14.
 */
var stream_params;
function get_params() { return stream_params; }

(function(){

        function listener(event){
            // if ( event.origin !== "http://localhost" )
            // return;
            //v1 = event.data;

            var str_input = event.data;
            var re_ui = /([^=,\.]*)=("[^"]*"|[^,"]*)/g;
            var match;

            var user_p = {

                ip  : null,
                port : null,
                camera : null,
                fps : null,
                resolution : null,
                quality : null,
                user: null,
                passwd : null,
                ptz : "",
                sound : "",
                logo : "",
                autoplay: ""

            };


            while (( match = re_ui.exec(str_input)) !== null)
            {
                user_p[match[1]] = match[2];
            }

            // геттеры и сеттеры возможно для пресетов
            Object.defineProperties(user_p, {
                "getRes": { get: function () { return this.resolution;  } },
                "setRes": { set: function (val) { this.resolution = val;  } }

            });


            Object.preventExtensions(user_p);

            if (user_p.passwd !="" || user_p.passwd !=null){
                var login = user_p.user;
            } else var login = user_p.user+":"+user_p.passwd;



            function get_meta() {

                sessionStorage.clear();
                var xhr = new XMLHttpRequest();
                xhr.open("GET","http://"+user_p.ip+":"+user_p.port+"/cameras/"+user_p.camera,true);
                xhr.withCredentials = true;
                xhr.setRequestHeader("Authorization","Basic "+btoa(login));
                xhr.setRequestHeader("Accept","application/json");
                xhr.onreadystatechange = function(){

                    if (this.readyState == 4){
                        var resp = JSON.parse(this.responseText);
                        document.getElementById('camera_name').innerHTML = resp.name;
                        sessionStorage.setItem("CAMERA",resp.name);
                    }

                }
                xhr.send(null);
            }

            setTimeout(get_meta,600);

        }

        //------end of onmessage event listener-----//
        if (window.addEventListener){
            window.addEventListener("message", listener,false);
        } else {
            window.attachEvent("onmessage", listener);
        }


})();




(function() {
    var
        fullScreenApi = {
            supportsFullScreen: false,
            isFullScreen: function() { return false; },
            requestFullScreen: function() {},
            cancelFullScreen: function() {},
            fullScreenEventName: '',
            prefix: ''
        },
        browserPrefixes = 'webkit moz o ms khtml'.split(' ');

    // check for native support
    if (typeof document.cancelFullScreen != 'undefined') {
        fullScreenApi.supportsFullScreen = true;
    } else {
        // check for fullscreen support by vendor prefix
        for (var i = 0, il = browserPrefixes.length; i < il; i++ ) {
            fullScreenApi.prefix = browserPrefixes[i];

            if (typeof document[fullScreenApi.prefix + 'CancelFullScreen' ] != 'undefined' ) {
                fullScreenApi.supportsFullScreen = true;

                break;
            }
        }
    }

    // update methods to do something useful
    if (fullScreenApi.supportsFullScreen) {
        fullScreenApi.fullScreenEventName = fullScreenApi.prefix + 'fullscreenchange';

        fullScreenApi.isFullScreen = function() {
            switch (this.prefix) {
                case '':
                    return document.fullScreen;
                case 'webkit':
                    return document.webkitIsFullScreen;
                default:
                    return document[this.prefix + 'FullScreen'];
            }
        }
        fullScreenApi.requestFullScreen = function(el) {
            return (this.prefix === '') ? el.requestFullScreen() : el[this.prefix + 'RequestFullScreen']();
        }
        fullScreenApi.cancelFullScreen = function(el) {
            return (this.prefix === '') ? document.cancelFullScreen() : document[this.prefix + 'CancelFullScreen']();
        }
    }

    // jQuery plugin
    if (typeof jQuery != 'undefined') {
        jQuery.fn.requestFullScreen = function() {

            return this.each(function() {
                var el = jQuery(this);
                if (fullScreenApi.supportsFullScreen) {
                    fullScreenApi.requestFullScreen(el);
                }
            });
        };
    }

    // export api
    window.fullScreenApi = fullScreenApi;
})();



(function() {
 $( document ).ready(function() {

     if (bowser.safari){
           $("#fsbutton").show();
           $("#fsBt").hide();

        }
     else {
         $("#fsbutton").hide();
         $("#fsBt").show();
     }




    var canvas = document.querySelector('.canva');
    var ctx = document.getElementsByClassName('canva')[0].getContext('2d');


     var fsButton = document.getElementById('fsbutton'),
         fsElement = document.getElementById('player')


     if (window.fullScreenApi.supportsFullScreen) {
         // handle button click
         fsButton.addEventListener('click', function() {
             window.fullScreenApi.requestFullScreen(fsElement);
         }, true);

         fsElement.addEventListener(fullScreenApi.fullScreenEventName, function() {
             //do something

         }, true);

     } else {

     }

    //var v1;

    function listener(event){
        // if ( event.origin !== "http://localhost" )
        // return;
        //v1 = event.data;

        var str_input = event.data;
        var re_ui = /([^=,\.]*)=("[^"]*"|[^,"]*)/g;
        var match;

        var user_p = {

            ip  : null,
            port : null,
            camera : null,
            fps : null,
            resolution : null,
            quality : null,
            user: null,
            passwd : null,
            ptz : "",
            sound : "",
            logo : "",
            autoplay: ""

        };


        while (( match = re_ui.exec(str_input)) !== null)
        {
            user_p[match[1]] = match[2];
        }


            // геттеры и сеттеры возможно для пресетов

            Object.defineProperties(user_p, {
                "getRes": { get: function () { return this.resolution;  } },
                "setRes": { set: function (val) { this.resolution = val;  } }

            });



        Object.preventExtensions(user_p);


            if (user_p.passwd !="" || user_p.passwd !=null){
                var login = user_p.user;
            } else var login = user_p.user+":"+user_p.passwd;


             if (user_p.autoplay =="true") { playVideo();}
              else if ((user_p.autoplay =="false")) { set_poster();}

             canvas.width = user_p.resolution.split("x")[0];
             canvas.height = user_p.resolution.split("x")[1];

             if (parseInt(user_p.resolution.split("x")[1]) < 400) {

                 $("#play").css({
                     margin: "-161px 10px 0 0",
                     height: '86px'
                   });
                 $("#controls button img").css({
                     width: "22px",
                     height: "22px"
                 });

                 $("#controls button").css({height: "0.5em"});
                 $("#controls").css({padding: "0px"});
                 $("#control-panel").css({height: "10%" });

              }



        function set_poster()
        {


            var   full_req = 'http://'+user_p.ip+":"+user_p.port+'/cameras/'+user_p.camera+'/image?' +
                'quality='+user_p.quality+'&resolution='+user_p.resolution;


            var cache_boost =  Math.floor(Math.random()*100);
            var xmlHTTP = new XMLHttpRequest();
            xmlHTTP.open('GET',full_req+"&rand="+cache_boost,true);

            xmlHTTP.responseType = 'arraybuffer';
            xmlHTTP.withCredentials = true;
            xmlHTTP.setRequestHeader("Authorization","Basic "+btoa(login));

            xmlHTTP.timeout = 2000;
            xmlHTTP.ontimeout = function() { set_poster();  }

            xmlHTTP.onload = function(ev)
            {

                var arr = new Uint8Array(this.response);
                var raw = String.fromCharCode.apply(null,arr);

                var b64=btoa(raw);
                var dataURL="data:image/jpeg;base64,"+b64;
                var startTime, endTime;
                var d_size = [this.getResponseHeader('Content-Length')];

                var poster = new Image();

                poster.addEventListener("load", function() {
                    ctx.drawImage(poster, 0, 0);

                },false);

                poster.src = dataURL;


            };
            xmlHTTP.send(null);

        }

        var animateID;
        var isPlaying = false;

	function play()
        {


           if (isPlaying){

             var   full_req = 'http://'+user_p.ip+":"+user_p.port+'/cameras/'+user_p.camera+'/image?' +
                    'quality='+user_p.quality+'&resolution='+user_p.resolution;
            
                        
            var cache_boost =  Math.floor(Math.random()*100000);
            var xmlHTTP = new XMLHttpRequest();

            xmlHTTP.open('GET',full_req+"&rand="+cache_boost,true);
            xmlHTTP.responseType = 'arraybuffer';
            xmlHTTP.withCredentials = true;
            xmlHTTP.setRequestHeader("Authorization","Basic "+btoa(login));

             xmlHTTP.timeout = 4000;
             xmlHTTP.ontimeout = function() { play(); }


            xmlHTTP.onload = function(ev)
            {

                var arr = new Uint8Array(this.response);
                var raw = String.fromCharCode.apply(null,arr);

                var b64=btoa(raw);
                var dataURL="data:image/jpeg;base64,"+b64;
                //document.getElementById("image").src = dataURL;

                 var d_size = this.getResponseHeader('Content-Length');

                    var frame = new Image();
                    frame.src = dataURL;
                    frame.addEventListener("load", function() {
                        ctx.drawImage(frame, 0, 0);
                        setTimeout(play,100);

                    },false);

              };

               xmlHTTP.onreadystatechange = function(){
                       if (this.readyState == 4 && this.statusText != 'OK') {
                           document.getElementById('camera_name').innerHTML = "Connection lost";
                           stopVideo();
                        }
                   else {
                           document.getElementById('camera_name').innerHTML = sessionStorage.getItem("CAMERA");
                        }

               }

               xmlHTTP.send(null);

           } else return;

        }



        function playVideo(){

            isPlaying = true;


            if( $("#playBtn").attr("src") == "img/play.png"){
                $("#playBtn").attr('src','img/pause.png');
                $("#play").hide();
                play();

              } else if ( $("#playBtn").attr("src") == "img/pause.png") {
                $("#playBtn").attr('src','img/play.png');
                $("#play").show();
                stopVideo();

                }
             return isPlaying;

        }


        function stopVideo() {

            //clearInterval(animateID);
            $("#playBtn").attr('src','img/play.png');
            $("#play").show();
            return isPlaying = false;
        }


        function resizeVideo() {


            var s1 = document.getElementById("play");
            //s1.style.marginTop = "-240px";

            if (bowser.msie){

                    if (!window.screenTop && !window.screenY) {
                        document.getElementById("play").style.marginTop = "-480px";
                    }
                     else {
                        if (parseInt(user_p.resolution.split("x")[1]) < 400) { document.getElementById("play").style.marginTop = "-161px"; }
                         else document.getElementById("play").style.marginTop = "-307px";
                     }

              }


            var container = document.getElementById('player'),
                computedStyle = window.getComputedStyle(container),
                containerWidth = parseInt(computedStyle.getPropertyValue('width')),
                containerHeight = parseInt(computedStyle.getPropertyValue('height'));


                var width = containerWidth,
                    height = canvas.height * width / canvas.width,
                    top = 0;

                if (height > containerHeight) {
                    height = containerHeight;
                    width = canvas.width * height / canvas.height;
                } else {
                    //top = Math.round((containerHeight - height) / 2);
                    top = 1;
                }


            canvas.style.width = window.innerWidth+"px";
             canvas.style.height = height + 'px';
            canvas.style.marginTop = top + 'px';


      }



        window.addEventListener('resize', resizeVideo);

        controls.querySelector('.play').addEventListener('click', playVideo);
        controls.querySelector('.fullscreen').addEventListener('click', function() {


            var fullscreenElement = document.fullscreenElement || document.mozFullScreenElement || document.webkitFullscreenElement || document.msFullscreenElement;
            if (fullscreenElement == player) {
                var cancelFullscreen = (document.cancelFullscreen || document.mozCancelFullScreen || document.webkitCancelFullScreen || document.msExitFullscreen).bind(document);
                cancelFullscreen();
            }

            else {
                var requestFullscreen = (player.requestFullscreen || player.mozRequestFullScreen || player.webkitRequestFullscreen || player.msRequestFullscreen).bind(player);
                requestFullscreen();
            }


        },false);

        document.addEventListener('fullscreenchange', resizeVideo);
        document.addEventListener('mozfullscreenchange', resizeVideo);
        document.addEventListener('webkitfullscreenchange', resizeVideo);
        document.addEventListener('MSFullscreenChange', resizeVideo);


        var fullscreenState = document.getElementById("fullscreen-state");
        if (fullscreenState) {

            if (!bowser.msie){

            document.addEventListener("fullscreenchange", function () {

                fullscreenState.innerHTML = (document.fullscreenElement)? "" : "not ";


                var s2 = $("#fullscreen-state").text();

                 if (parseInt(user_p.resolution.split("x")[1]) < 400) {
                     document.getElementById("play").style.marginTop = "-161px";
                  } else { document.getElementById("play").style.marginTop = "-307px";   }


                 if (s2 == ''){
                    document.getElementById("play").style.marginTop = "-480px";
                }

            }, false);

            document.addEventListener("msfullscreenchange", function () {
                fullscreenState.innerHTML = (document.msFullscreenElement)? "f" : "not ";

                var s2 = $("#fullscreen-state").text();

                if (parseInt(user_p.resolution.split("x")[1]) < 400) {
                    document.getElementById("play").style.marginTop = "-161px";
                } else { document.getElementById("play").style.marginTop = "-307px";   }

                 if (s2 == ''){
                    document.getElementById("play").style.marginTop = "-480px";
                  }

            }, false);

            document.addEventListener("mozfullscreenchange", function () {
                fullscreenState.innerHTML = (document.mozFullScreen)? "" : "not ";

                var s2 = $("#fullscreen-state").text();

                if (parseInt(user_p.resolution.split("x")[1]) < 400) {
                    document.getElementById("play").style.marginTop = "-161px";
                } else { document.getElementById("play").style.marginTop = "-307px";   }

                 if (s2 == ''){
                    document.getElementById("play").style.marginTop = "-480px";
                }
            }, false);

            document.addEventListener("webkitfullscreenchange", function () {
                fullscreenState.innerHTML = (document.webkitIsFullScreen)? "" : "not ";

                var s2 = $("#fullscreen-state").text();

                if (parseInt(user_p.resolution.split("x")[1]) < 400) {
                    document.getElementById("play").style.marginTop = "-161px";
                } else { document.getElementById("play").style.marginTop = "-307px";   }

               if (s2 == ''){
                    document.getElementById("play").style.marginTop = "-480px";
                }

            }, false);
           }
        }



        resizeVideo();

             $("#play").click(function(){
                 playVideo();
                 $("#play").hide();

                });




        controlPanel = document.getElementById('control-panel');
        var playerTimeout;
        function hideControlPanel() {
            if (controlPanel.style.opacity == 1.0) {
                controlPanel.style.opacity = 0.0;
                //topPanel.style.opacity = 0.0;
            }
            if (playerTimeout) {
                clearTimeout(playerTimeout);
                playerTimeout = null;
            }
        }
        function delayHideControlPanel() {
            if (playerTimeout) {
                clearTimeout(playerTimeout);
            }
            playerTimeout = setTimeout(function() {
                playerTimeout = null;
                controlPanel.style.opacity = 0.0;
                //topPanel.style.opacity = 0.0;
            }, 7000);
        }
        function showControlPanel() {
            if (controlPanel.style.opacity == 0.0) {
                controlPanel.style.opacity = 1.0;
                //topPanel.style.opacity = 1.0;
            }
        }
        player.addEventListener('mousemove', function() {
            showControlPanel();
            delayHideControlPanel();
        });
        delayHideControlPanel();


        function spacepressed(e) {

            var evtobj=window.event? event : e
            var unicode=evtobj.charCode? evtobj.charCode : evtobj.keyCode

            if (unicode=32)
                playVideo();

        }
        document.onkeypress=spacepressed;

    }

        //------end of onmessage event listener-----//
        if (window.addEventListener){
            window.addEventListener("message", listener,false);
        } else {
            window.attachEvent("onmessage", listener);
        }

  });
})();

